=== debian/changelog ===
iddawc (1.1.6-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update standards version to 4.6.1 (no change)
  * d/control: fix idwcc build by installing js libs in Build-Depends
  * lintian-overrides: ignore false positives

 -- Nicolas Mora <babelouest@debian.org>  Mon, 22 Aug 2022 07:54:29 -0400

iddawc (1.1.4-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sun, 05 Jun 2022 08:03:32 -0400

iddawc (1.1.3-1) unstable; urgency=medium

  * New upstream release
  * d/tests: Update unit-test

 -- Nicolas Mora <babelouest@debian.org>  Mon, 25 Apr 2022 19:27:34 -0400

iddawc (1.1.2-2) unstable; urgency=medium

  * d/patches: re-enable test.patch

 -- Nicolas Mora <babelouest@debian.org>  Thu, 14 Apr 2022 21:29:37 -0400

iddawc (1.1.2-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: update years
  * d/libiddawc1.1.symbols: update symbols
  * d/patches remove patches

 -- Nicolas Mora <babelouest@debian.org>  Mon, 11 Apr 2022 10:21:13 -0400
