=== debian/control ===
Source: iddawc
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , librhonabwy-dev
             , libgnutls28-dev
             , libjansson-dev
             , zlib1g-dev
             , cmake
             , pkg-config
             , check
             , doxygen
             , gnutls-bin
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
Standards-Version: 4.6.1
Homepage: https://github.com/babelouest/iddawc
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
Rules-Requires-Root: no

Package: libiddawc1.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libiddawc0.9 (<< 0.9.8-2)
Replaces: libiddawc0.9 (<< 0.9.8-2)
Description: OAuth2 and OIDC client library
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values

Package: libiddawc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiddawc1.1 (= ${binary:Version}), ${misc:Depends}
       , liborcania-dev
       , libyder-dev
       , libulfius-dev
       , librhonabwy-dev
       , libgnutls28-dev
       , libjansson-dev
       , zlib1g-dev
Description: OAuth2 and OIDC client library - development
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values
 .
 This package contains the development files.

Package: idwcc
Architecture: any
Depends: ${shlibs:Depends}
       , ${misc:Depends}
       , libiddawc1.1 (= ${binary:Version})
       , fonts-fork-awesome
       , libjs-jquery
       , libjs-bootstrap4
       , libjs-popper.js
Description: Client for OAuth2/OIDC AS configuration validation
 Provides a web application to be used as an OpenID Connect or OAuth2
 client.
 .
 Supports PKCE, token introspection, revocation, client registration,
 DPoP, Rich Authorization Request, Pushed Authorization Request,
 JWT Access tokens, encrypted tokens, requests and responses.
