## iddawc 1.1.7

=== debian/changelog ===
iddawc (1.1.7-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:25:27 -0400
