## iddawc 1.1.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,11 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "1")
-set(LIBRARY_VERSION_PATCH "6")
-set(ORCANIA_VERSION_REQUIRED "2.3.0")
-set(YDER_VERSION_REQUIRED "1.4.17")
-set(ULFIUS_VERSION_REQUIRED "2.7.10")
-set(RHONABWY_VERSION_REQUIRED "1.1.8")
+set(LIBRARY_VERSION_PATCH "8")
+set(ORCANIA_VERSION_REQUIRED "2.3.2")
+set(YDER_VERSION_REQUIRED "1.4.19")
+set(ULFIUS_VERSION_REQUIRED "2.7.12")
+set(RHONABWY_VERSION_REQUIRED "1.1.10")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -115,7 +115,7 @@
 
 add_library(iddawc SHARED ${LIB_SRC})
 set_target_properties(iddawc PROPERTIES
-        COMPILE_OPTIONS -Wextra
+        COMPILE_OPTIONS "-Wextra;-Wconversion"
         PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
         VERSION "${LIBRARY_VERSION}"
         SOVERSION "${LIBRARY_SOVERSION}")
@@ -163,20 +163,27 @@
     if (NOT ORCANIA_FOUND)
         if (DOWNLOAD_DEPENDENCIES)
             include(DownloadProject)
-            message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
             download_project(PROJ orcania # ... otherwise, download archive
-                    URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
-                    QUIET)
+                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
+                             QUIET)
             add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
             include_directories(${orcania_SOURCE_DIR}/include)
-            add_dependencies(iddawc orcania)
+            include_directories(${orcania_BINARY_DIR})
+            add_dependencies(yder orcania)
             set(ORCANIA_LIBRARIES orcania)
+            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+        else ()
+            message( FATAL_ERROR "Orcania not found")
+        endif ()
+    else()
+        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
+            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
+            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+            include_directories(${ORCANIA_INCLUDE_DIRS})
             include_directories(${orcania_BINARY_DIR})
         else ()
-            message( FATAL_ERROR "Orcania not found")
-        endif ()
-    else ()
-        include_directories(${ORCANIA_INCLUDE_DIRS})
+            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
+        endif ()
     endif ()
 endif ()
 target_link_libraries(iddawc ${ORCANIA_LIBRARIES})
@@ -190,23 +197,28 @@
     if (NOT YDER_FOUND)
         if (DOWNLOAD_DEPENDENCIES)
             include(DownloadProject)
-            message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
-            option(CHECK_ORCANIA "specific param" off)
             download_project(PROJ yder # ... otherwise, download archive
-                    URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
-                    QUIET)
+                              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
+                              QUIET)
             add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
             include_directories(${yder_SOURCE_DIR}/include)
-            include_directories(${orcania_SOURCE_DIR}/include)
             add_dependencies(iddawc yder)
-            set(YDER_LIBRARIES yder)
+            set(YDER_LIBRARIES yder orcania)
             include_directories(${yder_BINARY_DIR})
         else ()
             message( FATAL_ERROR "Yder not found")
         endif ()
-    else ()
-        include_directories(${YDER_INCLUDE_DIRS})
-    endif ()
+    else()
+        if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
+            message(STATUS "Yder found: ${YDER_VERSION_STRING}")
+            set(LIBS ${LIBS} ${YDER_LIBRARIES})
+            include_directories(${YDER_INCLUDE_DIRS})
+            include_directories(${yder_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
+        endif ()
+    endif ()
+    target_link_libraries(iddawc ${LIBS} ${YDER_LIBRARIES})
 endif ()
 target_link_libraries(iddawc ${YDER_LIBRARIES})
 set(LIBS ${LIBS} ${YDER_LIBRARIES})
@@ -223,8 +235,8 @@
             option(CHECK_YDER "specific param" off)
             message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
             download_project(PROJ ulfius
-                    URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
-                    QUIET)
+                             URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
+                             QUIET)
             add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
             include_directories(${yder_SOURCE_DIR}/include)
             include_directories(${orcania_SOURCE_DIR}/include)
@@ -236,7 +248,14 @@
             message( FATAL_ERROR "Ulfius not found")
         endif ()
     else ()
-        include_directories(${ULFIUS_INCLUDE_DIRS})
+        if ("${ULFIUS_VERSION_STRING}" VERSION_GREATER_EQUAL "${ULFIUS_VERSION_REQUIRED}")
+            message(STATUS "Ulfius found: ${ULFIUS_VERSION_STRING}")
+            set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})
+            include_directories(${ULFIUS_INCLUDE_DIRS})
+            include_directories(${yder_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Ulfius version required: ${ULFIUS_VERSION_REQUIRED} - version installed: ${ULFIUS_VERSION_STRING}")
+        endif ()
     endif ()
 endif ()
 target_link_libraries(iddawc ${ULFIUS_LIBRARIES})
@@ -289,34 +308,3 @@
       include_directories(${ZLIB_INCLUDE_DIRS})
     endif ()
     add_executable(idwcc ${IDWCC_DIR}/idwcc.c ${INC_DIR}/iddawc.h ${IDWCC_DIR}/http_compression_callback.c ${IDWCC_DIR}/http_compression_callback.h ${IDWCC_DIR}/static_compressed_inmemory_website_callback.c ${IDWCC_DIR}/static_compressed_inmemory_website_callback.h ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
-    set_target_properties(idwcc PROPERTIES SKIP_BUILD_RPATH TRUE)
-    add_dependencies(idwcc iddawc)
-    target_link_libraries(idwcc iddawc ${LIBS})
-    install(TARGETS idwcc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-    install(FILES ${IDWCC_DIR}/idwcc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
-    install(DIRECTORY ${IDWCC_DIR}/webapp/ DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/idwcc/webapp/ COMPONENT runtime)
-endif ()
-
-# documentation
-
-option(BUILD_IDDAWC_DOCUMENTATION "Build the documentation." OFF)
-if (BUILD_IDDAWC_DOCUMENTATION)
-    find_package(Doxygen)
-    if (DOXYGEN_FOUND)
-        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
-        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
-        
-        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
-        
-        add_custom_target(doc
-                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
-                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-                          COMMENT "Generating documentation with Doxygen"
-                          VERBATIM)
-
-    else ()
-        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
-    endif ()
-endif ()
-
-# build iddawc-cfg.h file
