=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
 	cd $(IDWCC_LOCATION) && $(MAKE) clean
 	cd $(TESTS_LOCATION) && $(MAKE) clean
-	rm -rf doc/html $(TESTS_LOCATION)/cert/*.crt $(TESTS_LOCATION)/cert/*.key $(TESTS_LOCATION)/cert/*.log
+	rm -rf doc/html/
 
 install:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) install
