=== debian/changelog ===
iddawc (1.1.8-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/copyright: Update copyright year to 2023 for debian/* files

 -- Nicolas Mora <babelouest@debian.org>  Wed, 11 Jan 2023 17:23:34 -0500
