=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
              , libjs-jquery
              , libjs-bootstrap4
              , libjs-popper.js
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/babelouest/iddawc
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
